[arch-commits] Commit in libldap/trunk (PKGBUILD ntlm.patch)
Ronald van Haren
ronald at archlinux.org
Thu Sep 25 11:28:34 UTC 2008
Date: Thursday, September 25, 2008 @ 07:28:33
Author: ronald
Revision: 12976
upgpkg: libldap 2.3.43-2
Added:
libldap/trunk/ntlm.patch
Modified:
libldap/trunk/PKGBUILD
------------+
PKGBUILD | 41 ++++++------
ntlm.patch | 189 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
2 files changed, 210 insertions(+), 20 deletions(-)
Modified: PKGBUILD
===================================================================
--- PKGBUILD 2008-09-25 10:26:56 UTC (rev 12975)
+++ PKGBUILD 2008-09-25 11:28:33 UTC (rev 12976)
@@ -1,28 +1,29 @@
# $Id$
-# Maintainer:
+# Maintainer:
# Contributor: Judd Vinet <jvinet at zeroflux.org>
-
pkgname=libldap
-pkgver=2.4.11
+pkgver=2.3.43
pkgrel=2
pkgdesc="LDAP client libraries"
-arch=('i686' 'x86_64')
+arch=(i686 x86_64)
license=('custom')
url="http://www.openldap.org/"
backup=(etc/openldap/ldap.conf)
depends=('libsasl' 'openssl>=0.9.8f')
-options=('!libtool' '!makeflags')
+options=('!libtool' '!makeflags' 'force')
makedepends=('tcp_wrappers')
source=(ftp://ftp.openldap.org/pub/OpenLDAP/openldap-release/openldap-${pkgver}.tgz
- getpeereid.patch)
-md5sums=('920fedbbb5bc61c2ca52c56edeef770a'
+ 'ntlm.patch' 'getpeereid.patch')
+md5sums=('1b25281086eb146b8e11ebd33de086dc'
+ '64c539d5f01f46f329b9d5c1324be4e9'
'c2b4328654f109adf6ad424d60d232c2')
build() {
cd ${srcdir}/openldap-${pkgver}
-
- patch -Np1 -i ${srcdir}/getpeereid.patch || return 1
+ patch -Np0 -i ${startdir}/src/ntlm.patch || return 1
+ patch -Np1 -i $srcdir/getpeereid.patch || return 1
+
./configure --prefix=/usr \
--libexecdir=/usr/sbin \
--sysconfdir=/etc \
@@ -36,26 +37,26 @@
make DESTDIR=${pkgdir} install || return 1
cd ../libraries
- make depend
+ make depend || return 1
make || return 1
- make DESTDIR=${pkgdir} install
+ make DESTDIR=${pkgdir} install || return 1
cd ../doc/man/man3
- make
- make DESTDIR=${startdir}/pkg install
+ make || return 1
+ make DESTDIR=${pkgdir} install || return 1
cd ../man5
- make
- install -Dm644 ldap.conf.5.tmp ${pkgdir}/usr/man/man5/ldap.conf.5
+ make || return 1
+ install -Dm644 ldap.conf.5.tmp \
+ ${pkgdir}/usr/man/man5/ldap.conf.5 || return 1
# get rid of duplicate default conf files
rm ${pkgdir}/etc/openldap/*.default
- ln -sf liblber.so ${pkgdir}/usr/lib/liblber.so.2
- ln -sf libldap.so ${pkgdir}/usr/lib/libldap.so.2
+ ln -sf liblber.so ${pkgdir}/usr/lib/liblber.so.2 || return 1
+ ln -sf libldap.so ${pkgdir}/usr/lib/libldap.so.2 || return 1
- # install custom license
- install -Dm644 ${srcdir}/openldap-${pkgver}/LICENSE \
- ${pkgdir}/usr/share/licenses/$pkgname/LICENSE
+ install -Dm644 ${startdir}/src/openldap-${pkgver}/LICENSE \
+ ${pkgdir}/usr/share/licenses/$pkgname/LICENSE
}
Added: ntlm.patch
===================================================================
--- ntlm.patch (rev 0)
+++ ntlm.patch 2008-09-25 11:28:33 UTC (rev 12976)
@@ -0,0 +1,189 @@
+--- libraries/libldap/Makefile.in.orig 2004-01-01 13:16:29.000000000 -0500
++++ libraries/libldap/Makefile.in 2004-07-14 13:37:23.000000000 -0400
+@@ -20,7 +20,7 @@
+ SRCS = bind.c open.c result.c error.c compare.c search.c \
+ controls.c messages.c references.c extended.c cyrus.c \
+ modify.c add.c modrdn.c delete.c abandon.c \
+- sasl.c sbind.c kbind.c unbind.c cancel.c \
++ sasl.c ntlm.c sbind.c kbind.c unbind.c cancel.c \
+ filter.c free.c sort.c passwd.c whoami.c \
+ getdn.c getentry.c getattr.c getvalues.c addentry.c \
+ request.c os-ip.c url.c sortctrl.c vlvctrl.c \
+@@ -29,7 +29,7 @@
+ OBJS = bind.lo open.lo result.lo error.lo compare.lo search.lo \
+ controls.lo messages.lo references.lo extended.lo cyrus.lo \
+ modify.lo add.lo modrdn.lo delete.lo abandon.lo \
+- sasl.lo sbind.lo kbind.lo unbind.lo cancel.lo \
++ sasl.lo ntlm.lo sbind.lo kbind.lo unbind.lo cancel.lo \
+ filter.lo free.lo sort.lo passwd.lo whoami.lo \
+ getdn.lo getentry.lo getattr.lo getvalues.lo addentry.lo \
+ request.lo os-ip.lo url.lo sortctrl.lo vlvctrl.lo \
+--- /dev/null 1970-01-01 01:00:00.000000000 +0100
++++ libraries/libldap/ntlm.c 2005-12-02 09:47:08.226364500 +0100
+@@ -0,0 +1,138 @@
++/* $OpenLDAP: pkg/ldap/libraries/libldap/ntlm.c,v 1.1.4.10 2002/01/04 20:38:21 kurt Exp $ */
++/*
++ * Copyright 1998-2002 The OpenLDAP Foundation, All Rights Reserved.
++ * COPYING RESTRICTIONS APPLY, see COPYRIGHT file
++ */
++
++/* Mostly copied from sasl.c */
++
++#include "portable.h"
++
++#include <stdlib.h>
++#include <stdio.h>
++
++#include <ac/socket.h>
++#include <ac/string.h>
++#include <ac/time.h>
++#include <ac/errno.h>
++
++#include "ldap-int.h"
++
++int
++ldap_ntlm_bind(
++ LDAP *ld,
++ LDAP_CONST char *dn,
++ ber_tag_t tag,
++ struct berval *cred,
++ LDAPControl **sctrls,
++ LDAPControl **cctrls,
++ int *msgidp )
++{
++ BerElement *ber;
++ int rc;
++ ber_int_t id;
++
++ Debug( LDAP_DEBUG_TRACE, "ldap_ntlm_bind\n", 0, 0, 0 );
++
++ assert( ld != NULL );
++ assert( LDAP_VALID( ld ) );
++ assert( msgidp != NULL );
++
++ if( msgidp == NULL ) {
++ ld->ld_errno = LDAP_PARAM_ERROR;
++ return ld->ld_errno;
++ }
++
++ /* create a message to send */
++ if ( (ber = ldap_alloc_ber_with_options( ld )) == NULL ) {
++ ld->ld_errno = LDAP_NO_MEMORY;
++ return ld->ld_errno;
++ }
++
++ assert( LBER_VALID( ber ) );
++
++ LDAP_NEXT_MSGID( ld, id );
++ rc = ber_printf( ber, "{it{istON}" /*}*/,
++ id, LDAP_REQ_BIND,
++ ld->ld_version, dn, tag,
++ cred );
++
++ /* Put Server Controls */
++ if( ldap_int_put_controls( ld, sctrls, ber ) != LDAP_SUCCESS ) {
++ ber_free( ber, 1 );
++ return ld->ld_errno;
++ }
++
++ if ( ber_printf( ber, /*{*/ "N}" ) == -1 ) {
++ ld->ld_errno = LDAP_ENCODING_ERROR;
++ ber_free( ber, 1 );
++ return ld->ld_errno;
++ }
++
++ /* send the message */
++ *msgidp = ldap_send_initial_request( ld, LDAP_REQ_BIND, dn, ber, id );
++
++ if(*msgidp < 0)
++ return ld->ld_errno;
++
++ return LDAP_SUCCESS;
++}
++
++int
++ldap_parse_ntlm_bind_result(
++ LDAP *ld,
++ LDAPMessage *res,
++ struct berval *challenge)
++{
++ ber_int_t errcode;
++ ber_tag_t tag;
++ BerElement *ber;
++ ber_len_t len;
++
++ Debug( LDAP_DEBUG_TRACE, "ldap_parse_ntlm_bind_result\n", 0, 0, 0 );
++
++ assert( ld != NULL );
++ assert( LDAP_VALID( ld ) );
++ assert( res != NULL );
++
++ if ( ld == NULL || res == NULL ) {
++ return LDAP_PARAM_ERROR;
++ }
++
++ if( res->lm_msgtype != LDAP_RES_BIND ) {
++ ld->ld_errno = LDAP_PARAM_ERROR;
++ return ld->ld_errno;
++ }
++
++ if ( ld->ld_error ) {
++ LDAP_FREE( ld->ld_error );
++ ld->ld_error = NULL;
++ }
++ if ( ld->ld_matched ) {
++ LDAP_FREE( ld->ld_matched );
++ ld->ld_matched = NULL;
++ }
++
++ /* parse results */
++
++ ber = ber_dup( res->lm_ber );
++
++ if( ber == NULL ) {
++ ld->ld_errno = LDAP_NO_MEMORY;
++ return ld->ld_errno;
++ }
++
++ tag = ber_scanf( ber, "{ioa" /*}*/,
++ &errcode, challenge, &ld->ld_error );
++ ber_free( ber, 0 );
++
++ if( tag == LBER_ERROR ) {
++ ld->ld_errno = LDAP_DECODING_ERROR;
++ return ld->ld_errno;
++ }
++
++ ld->ld_errno = errcode;
++
++ return( ld->ld_errno );
++}
++
+--- include/ldap.h.orig
++++ include/ldap.h
+@@ -2115,5 +2115,25 @@
+ ldap_passwordpolicy_err2txt LDAP_P(( LDAPPasswordPolicyError ));
+ #endif /* LDAP_CONTROL_PASSWORDPOLICYREQUEST */
+
++/*
++ * hacks for NTLM
++ */
++#define LDAP_AUTH_NTLM_REQUEST ((ber_tag_t) 0x8aU)
++#define LDAP_AUTH_NTLM_RESPONSE ((ber_tag_t) 0x8bU)
++LDAP_F( int )
++ldap_ntlm_bind LDAP_P((
++ LDAP *ld,
++ LDAP_CONST char *dn,
++ ber_tag_t tag,
++ struct berval *cred,
++ LDAPControl **sctrls,
++ LDAPControl **cctrls,
++ int *msgidp ));
++LDAP_F( int )
++ldap_parse_ntlm_bind_result LDAP_P((
++ LDAP *ld,
++ LDAPMessage *res,
++ struct berval *challenge));
++
+ LDAP_END_DECL
+ #endif /* _LDAP_H */
More information about the arch-commits
mailing list